using System.Data.Entity;
using System.Data.Entity.Core.Common;
using System.Data.SqlClient;
using System.Data.SQLite.EF6;
using SQLite.CodeFirst;

using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.Common;
using System.Data.Entity;
using System.Data.Entity.Core.Common;
using System.Data.SQLite;
using System.Data.SQLite.EF6;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Data.Sqlite;

namespace TourDataManager {

    public class SQLiteConfiguration  : DbConfiguration {
        
        
        protected internal SQLiteConfiguration (){
            SetProviderFactory("System.Data.SQLite", Microsoft.Data.Sqlite.SqliteFactory.Instance);
            SetProviderFactory("System.Data.SQLite.EF6", SQLiteProviderFactory.Instance);
            SetProviderServices("System.Data.SQLite", (DbProviderServices)SQLiteProviderFactory.Instance.GetService(typeof(DbProviderServices)));
        }
    }
    
    class SqliteDbConfiguration : DbConfiguration
    {
        public SqliteDbConfiguration()
        {
            string assemblyName = typeof (SQLiteProviderFactory).Assembly.GetName().Name;

            RegisterDbProviderFactories(assemblyName );
            SetProviderFactory(assemblyName, SqliteFactory.Instance);
            SetProviderFactory(assemblyName, SQLiteProviderFactory.Instance);
            SetProviderServices(assemblyName,
                (DbProviderServices) SQLiteProviderFactory.Instance.GetService(
                    typeof (DbProviderServices)));
        }

        static void RegisterDbProviderFactories(string assemblyName)
        {
            var dataSet = ConfigurationManager.GetSection("system.data") as DataSet;
            if (dataSet != null)
            {
                var dbProviderFactoriesDataTable = dataSet.Tables.OfType<DataTable>()
                    .First(x => x.TableName == typeof (DbProviderFactories).Name);

                var dataRow = dbProviderFactoriesDataTable.Rows.OfType<DataRow>()
                    .FirstOrDefault(x => x.ItemArray[2].ToString() == assemblyName);

                if (dataRow != null)
                    dbProviderFactoriesDataTable.Rows.Remove(dataRow);

                dbProviderFactoriesDataTable.Rows.Add(
                    "SQLite Data Provider (Entity Framework 6)",
                    ".NET Framework Data Provider for SQLite (Entity Framework 6)",
                    assemblyName,
                    typeof (SQLiteProviderFactory).AssemblyQualifiedName
                );
            }
        }
    }
    
    public class Foo {
        public long Id;
        public string Data;
    }

    [DbConfigurationType(typeof(SqliteDbConfiguration))]
    public class MyDbContext : DbContext{

        public static SqliteConnection GetConnection(){
            var connectionString = new SqliteConnectionStringBuilder{DataSource = "my.db"};
            var sqlConnection = new SqliteConnection{ConnectionString = connectionString.ConnectionString};
            return sqlConnection;
        }

        public MyDbContext() : base(GetConnection().ConnectionString){
           
        }
  
        protected override void OnModelCreating(DbModelBuilder modelBuilder){
            var sqliteConnectionInitializer = new SqliteCreateDatabaseIfNotExists<MyDbContext>(modelBuilder);
            Database.SetInitializer(sqliteConnectionInitializer);
        }

        public DbSet<Foo> Foo{ get; set; }


    }
    
    public class Db {
        public Db(){


            using (var db = new MyDbContext()){
                db.Foo.Add(new Foo{Id = 8, Data = "Yolo"});
                //db.SaveChanges();
            }
        }
    }
}